#include <stdlib.h>
#include "basic.h"
#include "monitor.h"

monitor_t *alloc_monitor(compose_t f,uintmax_t r) {
  monitor_t *p = malloc_check(sizeof(*p)) ;
  p->lock = alloc_mutex() ;
  p->cond = alloc_cond() ;
  p->nrun = 0 ;
  p->ncompleted = 0 ;
  p->r = r ;
  p->compose = f ;
  p->waiting = 0 ;
  return p ;
}

void free_monitor(monitor_t *p) {
  free_mutex(p->lock) ;
  free_cond(p->cond) ;
  free(p) ;
}

/* To be called by master to signal a task is being executed */
void enter_monitor(monitor_t *m) {
  // To Complete
}

/*
   To be called by worker :
   1. Pass partial result y, so as to update result of computation
      [m->r = m->compose(y,m->r)]
   2. Signal a taks is completed
*/
void leave_monitor(monitor_t *m,uintmax_t y) {
  // To complete
}

/* To be called by master to wait for ntaks being completed.
   returns computation result */
uintmax_t wait_monitor(monitor_t *m,int ntasks) {
  // To complete
  return m->r;
}
