#include "basic.h"

typedef struct {
  int maxrun,nrun ; /* Max number of running workers, running workers */
  int waiting ;     /* flag, true when master is waiting */
  pthread_mutex_t *lock ;
  pthread_cond_t *cond ;
} pool_t ;

pool_t *alloc_pool(int maxrun) ;
void free_pool(pool_t *p) ;

/* To be called by worker: tell pool a worker is free,
   may awake master if suspended */
void leave_pool(pool_t *p) ;

/* To be called by master: allocate a worker,
   suspend when none is available */
void look_pool(pool_t *p) ;
