#include "basic.h"

typedef struct {
  pthread_mutex_t *lock;
  pthread_cond_t *is_empty,*is_full;
  void * *t ;
  volatile int sp;
  int sz;
  // kill functionality
  int killed;
  volatile int seen;
  pthread_cond_t *wait;
} stack_t ;


stack_t *alloc_stack(int sz);
void free_stack(stack_t *p);

/* Blocking push and pop */

/* Notice it is an error to push on a killed stack */
void push(stack_t *p,void *q) ;

/* Pop behaviour:
  On a non-empty-stack: pop an item from the stack and return it.
  On an empty stack:
    - The stack is killed -> return NULL
    - The stack is alive  -> block
*/
void *pop(stack_t *p) ;


/* Killing the stack, to be called once.
   Returns when nprocs agents have attempted to pop the stack and
   returned NULL
*/
void kill(stack_t *p,int nprocs) ;
